#include "DistanceSensor.h"

// #include "NetworkPerception.h"
#include "Messages.h"
#include <math.h>

DistanceSensor::DistanceSensor() {
  this->type = Thing::DistanceSensorType;
  this->distance = INFINITY;
  this->triggerDistance = 1.0F;
}

DistanceSensor::DistanceSensor(float triggerDistance) : DistanceSensor() {
  this->triggerDistance = triggerDistance;
}

float DistanceSensor::GetDistance() {
  if (this->distance < minRange || this->distance > maxRange)
    return INFINITY; // invalid distance

  float d = this->distance;
  this->distance = INFINITY;
  return d;
};

bool DistanceSensor::ObjectNearby() {
  if (distance < minRange || distance > maxRange)
    return false;

  bool isOn = distance <= triggerDistance;
  return isOn;
}

void DistanceSensor::ProcessBytes(unsigned char *bytes) {
  unsigned char ix = 0;
  this->distance = Messages::ReceiveFloat16(bytes, &ix);
}
